namespace OptionsPattern.Sutdy.Advanced
{
    public class UseXunitTest:IDisposable
    {
        private readonly ITestOutputHelper? _output;
        private readonly IConfiguration _defaultConfig;
        public UseXunitTest(ITestOutputHelperAccessor outputHelperAccessor,IConfiguration configuration)
        {
            if (outputHelperAccessor == null)
            {
                throw new ArgumentNullException(nameof(outputHelperAccessor));
            }

            if (outputHelperAccessor == null)
            {
                throw new ArgumentNullException($" {nameof(outputHelperAccessor)} Ϊ null,  Startup.cs ע IConfiguration");
            }

            _output = outputHelperAccessor.Output;
            _defaultConfig = configuration;
        }

        
        /// <summary>
        /// xUnit Բ
        /// </summary>
        [Fact]
        public void UsabilityTest()
        {
            Assert.True(true, "6.2 ѡףʹxUnitԿܣ");
            _output?.WriteLine("6.2 ѡ ף");
        }

        /// <summary>
        ///  IoCлȡĬ
        ///  1 Xunit.DependencyInjection 
        ///  2Startup.cs Ĭ
        /// </summary>
        [Fact]
        public void GetIConfiguration_FromDI_ByStartup_Test()
        {
            var appOption = _defaultConfig.Get<AppOption>();

            Assert.NotNull(_defaultConfig);
            Assert.NotNull(appOption);
            Assert.Contains(nameof(AppOption.AppName), appOption.AppName);
        }

        /// <summary>
        /// Բ쳣
        /// ʹãxUnit ͨ
        /// </summary>
        [Fact]
        public void DoesNotThrow_Test()
        {
            //ִд
            Action codeSnippet = () =>
            {
                //ҵ

                //ģ쳣
                //throw new Exception("׳쳣");
            };

            var exception = Record.Exception(codeSnippet);
            Assert.Null(exception);

            _output?.WriteLine("ʹ xUnit ͨԲ쳣");
        }

        /// <summary>
        /// Բ쳣
        /// ʹãFluentAssertions ⷽʽԲ쳣
        /// </summary>
        [Fact]
        public void DoesNotThrow_UseFluentAssertions_Test()
        {
            //ִд
            Action codeSnippet= () =>
            {
                //ҵ

                //ģ쳣
                //throw new Exception("׳쳣");
            };

            //ԣ쳣
            codeSnippet.Should().NotThrow();

            _output?.WriteLine("ʹ FluentAssertions ⷽʽԲ쳣");
        }

        /// <summary>
        /// 
        /// </summary>
        public void Dispose()
        {
        }
    }
}